# Redmine - project management software
# Copyright (C) 2006-2013  Jean-Philippe Lang
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write tobthe Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# modified by longjun
# 统一route风格
# match 'path', :to => 'controller#action'
# 如果 path = controller#action 则 match 'path'
# Example:
# match 'welcome/course', :to => 'welcome#course' 变成
# match 'welcome/cource'
# 所有的 act: :act 变成  :act => :act
# Example: :via =>  :get ====> :via => :get

RedmineApp::Application.routes.draw do
  

  #match '/contests/:id/contestnotifications', :controller => 'contestnotifications', :action => 'index'

  resources :homework_users
  resources :no_uses
  delete 'no_uses', :to => 'no_uses#delete'

  resources :apply_project_masters
  delete 'apply_project_masters', :to => 'apply_project_masters#delete'

  resources :homework_attach do
    collection do
      get 'get_homework_member_list'
      match 'addjours', :via => [:get, :post]
      match 'add_jour_reply', :via => [:get,:post]
      match 'destroy_jour', :via => [:get,:post]
      match 'comprehensive_evaluation_jour', :via => [:get,:post]
      get 'get_not_batch_homework'
      get 'get_batch_homeworks'
      get 'get_homeworks'
      get 'get_homework_jours'
      get 'get_student_batch_homework'
      get 'get_my_homework'
    end
    member do
      match 'add_homework_users', :via => [:get,:post]
      match 'destory_homework_users', :via => [:get,:post]
      get 'praise_homework'
    end
  end

  resources :contest_notification

  resources :open_source_projects do
    collection do
      match 'search', :via => [:get, :post]
      match 'remove_condition', :via => [:get, :post]
      match 'allbug', :via => [:get, :post]
    end
    resources :relative_memos
    member do
      match 'master_apply', :via => [:get, :post]
      match 'accept_master_apply', :via => [:get, :post]
      match 'refuse_master_apply', :via => [:get, :post]
      match 'showmemo', :via =>  [:get, :post]
      match 'showbug', :via =>  [:get, :post]
    end
  end


  mount SeemsRateable::Engine => '/rateable', :as => :rateable

  namespace :zipdown do
    match 'assort'
    match 'download_user_homework', :as => :download_user_homework
  end
  namespace :test do
    match 'courselist'
    match 'zip'
  end
  ##new added by linchun #以发布应用的形式参与竞赛
  resources :softapplications do

    collection do
      match 'new_message',     :via => :get
      match 'search', :via => [:get, :post]
    end
    member do
      match 'create_message' , :via =>  :post
    end
  end

  #resources :notificationcomments do
  #
  #end

  #resources :contestnotifications, :only => [:index, :show, :edit, :update, :destroy]
  # match '/contestnotifications/:id/notificationcomments', :to => 'notificationcomments#create', :via => :post
  # match '/contestnotifications/:id/notificationcomments/:notificationcomment_id', :to => 'notificationcomments#destroy', :via => :delete
  ## new added by linchun #新竞赛相关
  resources :contests, only: [:index] do
    resources :contestnotifications do
      # get 'preview', on: :collection
      resources :notificationcomments 
    end

    collection do
      match 'new_contest'        , :via =>  :get
      match 'join_in_contest'    , :via =>  :post
      match 'unjoin_in_contest'  , :via =>  :delete
      match 'create_contest'     , :via =>  :post
      match 'new_join'           , :via =>  :post
      match 'new'                , :via =>  :post
    end
    member do
      delete 'destroy_contest'
      match 'add_softapplication'
      match 'update_contest'             , :via =>  [:put]
      match 'show_contest'               , :via =>  [:get, :post]
      match 'show_project'               , :via =>  :get
      match 'show_softapplication'       , :via =>  :get
      match 'show_attendingcontest'      , :via =>  :get
      #match 'show_notification'          , :via =>  :get
      match 'show_participator'          , :via =>  :get
      match 'set_reward_project'         , :via =>  [:get, :post]
      match 'set_reward_softapplication' , :via =>  [:get, :post]
      match 'add'                        , :via =>  [:get, :post]
      match 'add_softapplication'        , :via =>  [:get, :post]
      match 'create'                     , :via =>  :post
      match 'settings'                   , :via =>  [:get, :post]
      match 'show_contest_user'
      get 'watcherlist', :action=> 'watcherlist'
    end
  end

  match '/news/preview', :to => 'previews#news', :as => 'preview_news', :via => [:get, :post, :put]
  match '/issues/preview/new/:project_id', :to => 'previews#issue', :as => 'preview_new_issue', :via => [:get, :post, :put]
  match '/issues/preview/edit/:id', :to => 'previews#issue', :as => 'preview_edit_issue', :via => [:get, :post, :put]
  match '/issues/preview', :to => 'previews#issue', :as => 'preview_issue', :via => [:get, :post, :put]
  match '/contestnotifications/preview', :to => 'previews#contestnotification', :as => 'preview_contestnotifications', :via => [:get, :post, :put]

  #resource :previews, only: [] do
  #  collection do
  #    match 'news', :via => [:get, :post, :put]
  #    match 'issue', :via => [:get, :post, :put]
  #  end
  #end

  resources :stores do
    collection do
      match 'search', :via =>  [:get, :post]
    end
  end

  resources :forums do
    collection do
      match 'search_forum', :via => [:get, :post]

    end
    member do
      post 'create_memo'
      match 'search_memo', :via => [:get, :post]
    end
    resources :memos do
      collection do
        get "quote"
      end
    end
  end

  resources :shares

  #added by william
  get "tags/index"

  get "tags/show"

  get "praise_tread/praise_plus"

  get "praise_tread/tread_plus"
  #end

  root :to => 'welcome#index', :as => 'home'
  # added by longjun
  match 'welcome/contest',  :via => :get
  # end longjun

  #added by baiyu
  match 'git_usage/ch_usage',  :via => :get, :as => 'ch_usage'
  match 'git_usage/en_usage',  :via => :get, :as => 'en_usage'
  #added by nie
  match '/projects/search',  :via => [:get, :post]
  match '/users/search', :via => [:get, :post]
  #end
  match 'login', :to => 'account#login', :as => 'signin', :via => [:get, :post]
  match 'logout', :to => 'account#logout', :as => 'signout', :via => [:get, :post]
  match 'account/register', :via => [:get, :post], :as => 'register'
  match 'account/lost_password',  :via => [:get, :post], :as => 'lost_password'
  match 'account/activate',  :via => :get
  match 'account/valid_ajax',  :via => :get
  match 'account/email_valid', :to => 'account#email_valid', :via => :get
  match 'account/resendmail', :to => 'account#resendmail', :via=> :get
  match 'projects/:id/wiki', :to => 'wikis#edit', :via => :post
  match 'projects/:id/wiki/destroy', :to => 'wikis#destroy', :via => [:get, :post]

  # boards
  match 'boards/:board_id/topics/new', :to => 'messages#new', :via => [:get, :post], :as => 'new_board_message'
  get 'boards/:board_id/topics/:id', :to => 'messages#show', :as => 'board_message'
  match 'boards/:board_id/topics/quote/:id', :to => 'messages#quote', :via => [:get, :post]
  get 'boards/:board_id/topics/:id/edit', :to => 'messages#edit'

  post 'boards/:board_id/topics/preview', :to => 'messages#preview', :as => 'preview_board_message'
  post 'boards/:board_id/topics/:id/replies', :to => 'messages#reply'
  post 'boards/:board_id/topics/:id/edit', :to => 'messages#edit'
  post 'boards/:board_id/topics/:id/destroy', :to => 'messages#destroy'
  # boards end
  post 'bids/homework_destroy', :to => 'bids#homework_destroy'

  # Misc issue routes. TODO: move into resources
  match '/issues/auto_complete', :to => 'auto_completes#issues', :via => :get, :as => 'auto_complete_issues'
  match '/issues/context_menu', :to => 'context_menus#issues', :as => 'issues_context_menu', :via => [:get, :post]
  match '/issues/changes', :to => 'journals#index', :as => 'issue_changes', :via => :get
  match '/issues/:id/quoted', :to => 'journals#new', :id => /\d+/, :via => :post, :as => 'quoted_issue'

  match '/journals/diff/:id', :to => 'journals#diff', :id => /\d+/, :via => :get
  match '/journals/edit/:id', :to => 'journals#edit', :id => /\d+/, :via => [:get, :post]
  match '/journals/destroy/:id', :to => 'journals#destroy', :id => /\d+/, :via => [:get, :post]

  get '/projects/:project_id/issues/gantt', :to => 'gantts#show', :as => 'project_gantt'
  get '/issues/gantt', :to => 'gantts#show'

  get '/projects/:project_id/issues/calendar', :to => 'calendars#show', :as => 'project_calendar'
  get '/issues/calendar', :to => 'calendars#show'

  get 'projects/:id/issues/report', :to => 'reports#issue_report', :as => 'project_issues_report'
  get 'projects/:id/issues/report/:detail', :to => 'reports#issue_report_details', :as => 'project_issues_report_details'
  post '/users/:id/user_activities', :to => 'users#show', :as => "user_activities"

  #added by young
  resources :users do
    collection do
      match "tag_saveEx" , :via =>  [:get, :post]
    end
    member do
      match 'user_projects_index', :to => 'users#user_projects_index', :via => :get
      match 'user_projects', :to => 'users#user_projects',  :via => :get
      match 'user_activities', :to => 'users#user_activities',  :via => :get, :as => "user_activities"
      match 'user_newfeedback', :to => 'users#user_newfeedback',  :via => :get, :as => "user_newfeedback"
      match 'watch_calls', :to => 'users#watch_bids', :via => [:get , :post]
      match 'info', :to => 'users#info', :via => [:get , :post], :as => 'user_info'
      match 'user_watchlist', :to => 'users#user_watchlist',  :via => :get, :as => "user_watchlist" #add by huang
      match 'user_fanslist', :to => 'users#user_fanslist',  :via => :get, :as => "user_fanslist" #add by huang
      match 'user_courses', :to => 'users#user_courses', :via => :get
      match 'user_homeworks', :to => 'users#user_homeworks', :via => :get
      match 'watch_projects', :to => 'users#watch_projects', :via => :get
      # added by bai
      match 'show_score', :to => 'users#show_score', :via => :get
      match 'topic_score_index', :to => 'users#topic_score_index', :via => [:get, :post]
      match 'project_score_index', :to => 'users#project_score_index', :via => :get
      match 'activity_score_index', :to => 'users#activity_score_index', :via => :get
      match 'influence_score_index', :to => 'users#influence_score_index', :via => :get
      match 'score_index', :to => 'users#score_index', :via => :get

      match 'show_new_score', :to => 'users#show_new_score', :via => :get
      match 'topic_new_score_index', :to => 'users#topic_new_score_index', :via => [:get, :post]
      match 'project_new_score_index', :to => 'users#project_new_score_index', :via => :get
      match 'activity_new_score_index', :to => 'users#activity_new_score_index', :via => :get
      match 'influence_new_score_index', :to => 'users#influence_new_score_index', :via => :get
      match 'score_new_index', :to => 'users#score_new_index', :via => :get
      match 'update_score', :to => 'users#update_score', :via => [:get,:post]

      match 'show_projects_score', :to => 'projects#show_projects_score', :via => [:get, :post]
      match 'issue_score_index', :to => 'projects#issue_score_index', :via => [:get, :post]
      match 'news_score_index', :to => 'projects#news_score_index', :via => [:get, :post]
      match 'file_score_index', :to => 'projects#file_score_index', :via => [:get, :post]
      match 'code_submit_score_index', :to => 'projects#code_submit_score_index', :via => [:get, :post]
      match 'projects_topic_score_index', :to => 'projects#projects_topic_score_index', :via => [:get, :post]
    # end
    end
  end
  match 'users/:id/user_newfeedback', :to => 'users#user_newfeedback',  :via => :get, :as => "feedback"
  match 'users/:id/user_projects', :to => 'users#user_projects',  :via => :get
  #match 'user/:id/watch_calls', :controller => 'users', :action => 'watch_bids', :via => [:get , :post]

  #end
  match 'my/account',  :via => [:get, :post]
  match 'my/account/destroy', :to => 'my#destroy', :via => [:get, :post]
  match 'my/page',  :via => :get
  match 'my', :to => 'my#index', :via => :get # Redirects to my/page
  match 'my/reset_rss_key',  :via => :post
  match 'my/reset_api_key',  :via => :post
  match 'my/password',  :via => [:get, :post]
  match 'my/page_layout', :via => :get
  match 'my/add_block',  :via => :post
  match 'my/remove_block',  :via => :post
  match 'my/order_blocks',  :via => :post

  get 'my/page2', :to => 'my#page2',  :as => "my_page2"

  resources :users
  match 'users/:id/memberships/:membership_id', :to => 'users#edit_membership', :via => :put, :as => 'user_membership'
  match 'users/:id/memberships/:membership_id', :to => 'users#destroy_membership', :via => :delete
  match 'users/:id/memberships', :to => 'users#edit_membership', :via => :post, :as => 'user_memberships'
  #################  added by william
  match 'users/tag_save', :via => :post, :as => 'tag'
  match 'users/tag_saveEx',  :via => [:get, :post]

  post 'watchers/watch', :to => 'watchers#watch', :as => 'watch'
  delete 'watchers/watch', :to => 'watchers#unwatch'
  get 'watchers/new', :to => 'watchers#new'
  post 'watchers', :to => 'watchers#create'
  post 'watchers/append', :to => 'watchers#append'
  delete 'watchers', :to => 'watchers#destroy'
  get 'watchers/autocomplete_for_user', :to => 'watchers#autocomplete_for_user'
  # Specific routes for issue watchers API
  post 'issues/:object_id/watchers', :to => 'watchers#create', :object_type => 'issue'
  delete 'issues/:object_id/watchers/:user_id' => 'watchers#destroy', :object_type => 'issue'

  post 'appliedproject/applied', :to => 'applied_project#applied_join_project', :as => 'appliedproject'
  delete 'appliedproject/applied', :to => 'applied_project#unapplied_join_project'

  resources :bids, :only=>[:edit,:update,:show] do
    member do
      match 'homework_ajax_modal'
      get 'start_anonymous_comment', as: 'start_anonymous_comment'
      get 'stop_anonymous_comment', as: 'stop_anonymous_comment'
      get 'alert_anonymous_comment'
    end
  end
  resources :projects do
    member do
      get 'settings(/:tab)', :action => 'settings', :as => 'settings'
      #by young
      get 'member', :to => 'projects#member', :as => 'member'
      get 'file', :action => 'file', :as => 'file'
      get 'statistics', :action => 'statistics', :as => 'statistics'

      get 'feedback', :action => 'feedback', :as => 'project_feedback'
      get 'watcherlist', :action=> 'watcherlist'
      match 'user_watcherlist', :to => 'projects#watcherlist',  :via => :get, :as => "watcherlist" #add by huang
      get 'homework', :action => 'homework', :as => 'homework'
      get 'new_homework', :action => 'new_homework', :as => 'new_homework'
      #get 'news', :action => 'news', :as => 'news'
      #end
      post 'modules'
      post 'archive'
      post 'unarchive'
      post 'close'
      post 'reopen'
      match 'copy', :via => [:get, :post]
    end

    #by young
    match '/member', :to => 'projects#member',  :as => 'member', :via => :get
    match '/file', :to => 'projects#file',  :as => 'file', :via => :get
    match '/statistics', :to => 'projects#statistics',  :as => 'statistics', :via => :get
    #   match '/investor', :controller => 'projects', :action => 'investor',  :as => 'investor', :via => :get
    match '/homework', :to => 'projects#homework', :as => 'homework', :via => :get

    #   match '/activity', :controller => 'activities', :action => 'index',  :as => 'activity', :via => :get
    #   match '/repository', :controller => 'repositories', :action => 'show', :repository_id => nil, :path => nil, :rev => nil, :as => 'repository', :via => :get
    #   match '/', :controller => 'projects', :action => 'show', :as => 'project_show', :via => :get
    #   get 'projects/:project_id/show', :to => 'projects#show', :as => 'project_show'
    #   get 'projects/:project_id/repository', :to => 'repositories#show', :as => 'project_repository'

    #   match '/show', :controller => 'projects', :action => 'show',  :as => 'project_show', :via => :get
    match '/watcherlist', :to=>'projects#watcherlist', :as => 'watcherlist', :via => :get  #add by huang
    # matche '/news', :controller => 'news', :action => 'index', :as => 'news', :via => :get
    #end

    resources :memberships, :shallow => true, :controller => 'members', :only => [:index, :show, :new, :create, :update, :destroy] do
      collection do
        get 'autocomplete'
        get 'appliedproject'
      end
    end

    resource :enumerations, :controller => 'project_enumerations', :only => [:update, :destroy]

    get 'issues/:copy_from/copy', :to => 'issues#new', :as => 'copy_issue'
    resources :issues, :only => [:index, :new, :create] do
      resources :time_entries, :controller => 'timelog' do
        collection do
          get 'report'
        end
      end
    end
    # issue form update
    match 'issues/update_form', :to => 'issues#update_form', :via => [:put, :post], :as => 'issue_form'

    resources :files, :only => [:index, :new, :create] do
      collection do
        match "getattachtype" , :via =>  [:get, :post]
      #match 'getattachtype/:attachtype', :to => 'files#getattachtype', :via =>  [:get, :post]
      end
    end


    resources :versions, :except => [:index, :show, :edit, :update, :destroy] do
      collection do
        put 'close_completed'
      end
    end
    get 'versions.:format', :to => 'versions#index'
    get 'roadmap', :to => 'versions#index', :format => false
    get 'versions', :to => 'versions#index'

    resources :news, :except => [:show, :edit, :update, :destroy]
    resources :time_entries, :controller => 'timelog' do
      get 'report', :on => :collection
    end
    resources :queries, :only => [:new, :create]
    resources :issue_categories, :shallow => true
    resources :documents, :except => [:show, :edit, :update, :destroy]
    resources :boards
    resources :repositories, :shallow => true, :except => [:index, :show] do
      member do
        match 'committers', :via => [:get, :post]
      end
    end
    resources :repositories, :except => [:index, :show] do
      member do
        get 'newrepo', :via => [:get, :post]
      # get 'create', :via=>[:get, :post]
      end
    end
    match 'wiki/index',  :via => :get
    resources :wiki, :except => [:index, :new, :create], :as => 'wiki_page' do
      member do
        get 'rename'
        post 'rename'
        get 'history'
        get 'diff'
        match 'preview', :via => [:post, :put]
        post 'protect'
        post 'add_attachment'
      end
      collection do
        get 'export'
        get 'date_index'
      end
    end
    match 'wiki', :to => 'wiki#show', :via => :get
    get 'wiki/:id/:version', :to => 'wiki#show', :constraints => {:version => /\d+/}
    delete 'wiki/:id/:version', :to => 'wiki#destroy_version'
    get 'wiki/:id/:version/annotate', :to => 'wiki#annotate'
    get 'wiki/:id/:version/diff', :to => 'wiki#diff'
  end

  resources :issues do
    collection do
      match 'bulk_edit', :via => [:get, :post]
      post 'bulk_update'
    end
    resources :time_entries, :controller => 'timelog' do
      collection do
        get 'report'
      end
    end
    resources :relations, :shallow => true, :controller => 'issue_relations', :only => [:index, :show, :create, :destroy]
  end
  match '/issues', :to => 'issues#destroy', :via => :delete

  resources :queries, :except => [:show]

  resources :news, :only => [:index, :show, :edit, :update, :destroy]
  match '/news/:id/comments', :to => 'comments#create', :via => :post
  #match '/news/:id/comments/:comment_id', :to => 'comments#destroy', :via => :delete
  delete '/news/:id/comments/:comment_id', :to => 'comments#destroy', as: :delete_news_comments

  resources :versions, :only => [:show, :edit, :update, :destroy] do
    post 'status_by', :on => :member
  end

  resources :documents, :only => [:show, :edit, :update, :destroy] do
    post 'add_attachment', :on => :member
  end

  match '/time_entries/context_menu', :to => 'context_menus#time_entries', :as => :time_entries_context_menu, :via => [:get, :post]

  resources :time_entries, :controller => 'timelog', :except => :destroy do
    collection do
      get 'report'
      get 'bulk_edit'
      post 'bulk_update'
    end
  end
  match '/time_entries/:id', :to => 'timelog#destroy', :via => :delete, :id => /\d+/
  # TODO: delete /time_entries for bulk deletion
  match '/time_entries/destroy', :to => 'timelog#destroy', :via => :delete

  get 'projects/:id/activity', :to => 'activities#index'
  get 'projects/:id/activity.:format', :to => 'activities#index'
  get 'activity', :to => 'activities#index'

  # repositories routes
  get 'projects/:id/repository/:repository_id/statistics', :to => 'repositories#stats'
  get 'projects/:id/repository/:repository_id/graph', :to => 'repositories#graph'

  get 'projects/:id/repository/:repository_id/changes(/*path(.:ext))', :to => 'repositories#changes'

  get 'projects/:id/repository/:repository_id/revisions/:rev', :to => 'repositories#revision'
  get 'projects/:id/repository/:repository_id/revision', :to => 'repositories#revision'
  post   'projects/:id/repository/:repository_id/revisions/:rev/issues', :to => 'repositories#add_related_issue'
  delete 'projects/:id/repository/:repository_id/revisions/:rev/issues/:issue_id', :to => 'repositories#remove_related_issue'
  get 'projects/:id/repository/:repository_id/revisions', :to => 'repositories#revisions'
  get 'projects/:id/repository/:repository_id/revisions/:rev/:action(/*path(.:ext))',
      :controller => 'repositories',
      :format => false,
      :constraints => {
        :action => /(browse|show|entry|raw|annotate|diff)/,
        :rev    => /[a-z0-9\.\-_]+/
      }

  get 'projects/:id/repository/statistics', :to => 'repositories#stats'
  get 'projects/:id/repository/graph', :to => 'repositories#graph'

  get 'projects/:id/repository/changes(/*path(.:ext))', :to => 'repositories#changes'

  get 'projects/:id/repository/revisions', :to => 'repositories#revisions'
  get 'projects/:id/repository/revisions/:rev', :to => 'repositories#revision'
  get 'projects/:id/repository/revision', :to => 'repositories#revision'
  post   'projects/:id/repository/revisions/:rev/issues', :to => 'repositories#add_related_issue'
  delete 'projects/:id/repository/revisions/:rev/issues/:issue_id', :to => 'repositories#remove_related_issue'
  get 'projects/:id/repository/revisions/:rev/:action(/*path(.:ext))',
      :controller => 'repositories',
      :format => false,
      :constraints => {
        :action => /(browse|show|entry|raw|annotate|diff)/,
        :rev    => /[a-z0-9\.\-_]+/
      }
  get 'projects/:id/repository/:repository_id/:action(/*path(.:ext))',
      :controller => 'repositories',
      :action => /(browse|show|entry|raw|changes|annotate|diff)/
  get 'projects/:id/repository/:action(/*path(.:ext))',
      :controller => 'repositories',
      :action => /(browse|show|entry|raw|changes|annotate|diff)/

  get 'projects/:id/repository/:repository_id', :to => 'repositories#show', :path => nil
  get 'projects/:id/repository', :to => 'repositories#show', :path => nil
  get 'projects/:id/exit', :to => 'projects#exit_project', :as => 'exit_cur_project'

  # additional routes for having the file name at the end of url
  get 'attachments/:id/:filename', :to => 'attachments#show', :id => /\d+/, :filename => /.*/, :as => 'named_attachment'
  get 'attachments/download/:id/:filename', :to => 'attachments#download', :id => /\d+/, :filename => /.*/, :as => 'download_named_attachment'
  get 'attachments/download/:id', :to => 'attachments#download', :id => /\d+/
  get 'attachments/thumbnail/:id(/:size)', :to => 'attachments#thumbnail', :id => /\d+/, :size => /\d+/, :as => 'thumbnail'
  get 'attachments/autocomplete'
  match 'attachments/autocomplete', :to => 'attachments#autocomplete', :via =>  [:post]
  post 'attachments/relationfile', to: 'attachments#add_exist_file_to_project', as: 'attach_relation'
  post 'attachments/courserelationfile', to: 'attachments#add_exist_file_to_course', as: 'course_attach_relation'
  post 'attachments/courserelationfiles', to: 'attachments#add_exist_file_to_courses', as: 'course_attach_relations'
  get  'attachments/renderTag/:attchmentId', :to => 'attachments#renderTag', :attchmentId => /\d+/
  resources :attachments, :only => [:show, :destroy]  do
    collection do
      match "updateType" , :via =>  [:get, :post]
      match "updateFileDense" , :via =>  [:get, :post]
      match "update_file_dense", :via => [:post]
      match "renderTag" , :via =>  [:get, :post]
      match 'delete_softapplications', :via =>  [:get, :post]
    end
  end

  resources :groups do
    member do
      get 'autocomplete_for_user'
    end
  end

  match 'groups/:id/users', :to => 'groups#add_users', :id => /\d+/, :via => :post, :as => 'group_users'
  match 'groups/:id/users/:user_id', :to => 'groups#remove_user', :id => /\d+/, :via => :delete, :as => 'group_user'
  match 'groups/destroy_membership/:id', :to => 'groups#destroy_membership', :id => /\d+/, :via => :post
  match 'groups/edit_membership/:id', :to => 'groups#edit_membership', :id => /\d+/, :via => :post

  resources :trackers, :except => :show do
    collection do
      match 'fields', :via => [:get, :post]
    end
  end
  resources :issue_statuses, :except => :show do
    collection do
      post 'update_issue_done_ratio'
    end
  end
  resources :custom_fields, :except => :show
  resources :roles do
    collection do
      match 'permissions', :via => [:get, :post]
    end
  end
  resources :web_footer_companies, :except => :show
  resources :enumerations, :except => :show
  match 'enumerations/:type', :to => 'enumerations#index', :via => :get

  get 'projects/:id/search', :controller => 'search', :action => 'index'
  get 'search', :controller => 'search', :action => 'index'

  match 'mail_handler', :to => 'mail_handler#index', :via => :post
  match 'mail_handler/cancel/:id', :to => 'mail_handler#cancel_mail_notify',:via => :get

  match 'admin', :to => 'admin#index', :via => :get
  match 'admin/projects',  :via => :get
  match 'admin/users',  :via => :get
  match 'admin/first_page_made', as: :first_page_made
  match 'admin/course_page_made', as: :course_page_made
  match 'admin/contest_page_made', as: :contest_page_made
  match 'admin/web_footer_made', as: :web_footer_made
  match 'admin/search',  :via => [:get, :post]
  match 'admin/plugins',  :via => :get
  match 'admin/info',  :via => :get
  match 'admin/test_email',  :via => :get
  match 'admin/default_configuration', :via => :post

  resources :auth_sources do
    member do
      get 'test_connection', :as => 'try_connection'
    end
    collection do
        get 'autocomplete_for_new_user'
    end
  end

  match 'courses/search'
  match '/contests/search', :via => [:get, :post]
  # add by nwb
  # 课程路由设置
  resources :courses do
    member do
      get 'settings(/:tab)', :action => 'settings', :as => 'settings'
      get 'homework', :action => 'homework', :as => 'homework'
      get 'new_homework', :action => 'new_homework', :as => 'new_homework'
      get 'file', :action => 'file', :as => 'file'
      get 'feedback', :action => 'feedback', :as => 'course_feedback'
      get 'member', :controller => 'courses', :action => 'member', :as => 'member'
      get 'export_course_member_excel',:controller => 'courses',:action => 'export_course_member_excel'
      get 'member_score', :to => 'courses#member_score'
      post 'finishcourse'
      post 'restartcourse'
      match "searchmembers", :controller => 'courses', :action => 'searchmembers', :via => [:post,:get]
      match "searchgroupmembers", :via => [:post, :get]
      match 'member_score_sort', :via => [:get]
      match "updategroupname", :via => [:post, :get]
      match "addgroups",  :via => [:post, :get]
      match 'deletegroup', :via => [:delete]
      match 'show_member_score', :via => [:get]
      match 'valid_ajax', :to => 'courses#valid_ajax', :via => :get
      post 'join_in/join_group', :to => 'courses#join_group', :as => 'join_group'
      delete 'join_in/join_group', :to => 'courses#unjoin_group'
    end
    collection do
      match 'join_private_courses', :via => [:get, :post]

    end

    match '/member', :to => 'courses#member',  :as => 'member', :via => :get
    resources :boards
    resources :files, :only => [:index, :new, :create] do
      collection do
        match "getattachtype", :via =>  [:get, :post]
        match "search",:via => [:post,:get]
      end
      member do
        match "quote_resource_show", :via => [:get]
      end
    end
    resources :memberships, :shallow => true, :controller => 'members', :only => [:index, :show, :new, :create, :update, :destroy] do
      collection do
        get 'autocomplete'
        get 'appliedproject'
      end
    end
    resources :news, :except => [:show, :edit, :update, :destroy]
    resources :boards
    match '/homework', :to => 'courses#homework', :as => 'homework', :via => :get
  end   # end of resources :courses
  match 'courses/:id/feedback', :to => 'courses#feedback',  :via => :get, :as => 'course_feedback'
  match '/courses/search',  :via => [:get, :post]
  match 'words/:id/leave_course_message', :to => 'words#leave_course_message'


  match 'workflows', :to => 'workflows#index', :via => :get
  match 'workflows/edit',  :via => [:get, :post]
  match 'workflows/permissions',  :via => [:get, :post]
  match 'workflows/copy',  :via => [:get, :post]
  match 'settings', :controller => 'settings', :action => 'index', :via => :get
  match 'settings/edit',  :via => [:get, :post]
  match 'settings/plugin/:id', :to => 'settings#plugin', :via => [:get, :post], :as => 'plugin_settings'

  match 'sys/projects',  :via => :get
  match 'sys/projects/:id/repository', :to => 'sys#create_project_repository', :via => :post
  match 'sys/fetch_changesets', :via => :get

  match 'uploads', :to => 'attachments#upload', :via => :post
  # Added by Tao
  match 'upload_avatar', :to => 'avatar#upload', :via => :post
  match 'delete_avatar', :to => 'avatar#delete_image',:via => :post
  # Endof Tao's code
  get 'robots.txt', :to => 'welcome#robots'
  match 'welcome/course', :to => 'welcome#course'
  ##############测试留言功能    fq
  post 'words/new', :to => 'words#new'
  post 'words/create', :to => 'words#create'
  post 'words/append', :to => 'words#append'
  post 'words/create_reply', :to => 'words#create_reply'
  delete 'words/destroy', :to => 'words#destroy'
  delete 'words/destroyJournal', :to => 'words#destroyJournal'
  get 'words/more', :to => 'words#more'
  get 'words/back', :to=> 'words#back'
  get 'words/destroyJournal', :to => 'words#destroyJournal'
  ############## fq
  post 'calls/create', :to => 'bids#create'
  delete 'calls/destroy', :to => 'bids#destroy'
  match 'calls/new', :to => 'bids#new', :via => [:get , :post]
  get 'calls/more', :to => 'bids#more'
  get 'calls/back', :to=> 'bids#back'
  match 'calls/new_bid', :to => 'bids#new_bid'
  match 'contest/new_contest', :to => 'bids#new_contest' #huang
  match 'calls/:id/show_project', :to => 'bids#show_project', :as => 'project_for_bid'
  match 'calls/:id/show_course', :to => 'bids#show_courseEx', :as => 'course_for_bid'  # nwb added
  match 'calls/:id/new_exercise_book', :to => 'homework_attach#new', :as => 'new_exercise_book'
  match 'calls/:id/add', :to => 'bids#add'
  match 'calls/:id/delete', :to => 'bids#delete'
  match 'calls/:id/add_homework', :to => 'bids#add_homework', :via =>  :post
  match 'calls/:id/new_submit_homework', :to => 'bids#new_submit_homework', :via =>  :get, :as => 'new_submit_homework'
  match 'words/add_project_respond', :to => 'words#add_project_respond'
  match 'words/:id/leave_project_message', :to => 'words#leave_project_message'

  match 'projects/:id/feedback', :to => 'projects#feedback',  :via => :get, :as => 'project_feedback'
  match 'calls/create_bid', :to => 'bids#create_bid'
  match 'contest/create_contest', :to => 'bids#create_contest' #huang
  match 'calls/create_homework', :to => 'bids#create_homework'
  match 'calls/:id/homework_respond', :to => 'bids#homework_respond'
  match 'calls/:id/homework_statistics', :to => 'bids#homework_statistics'
  match 'calls/:id/fork', :to => 'bids#fork', :as => 'fork'
  match 'calls/:id/create_fork', :to => 'bids#create_fork'

  match 'calls/:id/show_course', :to => 'bids#show_course', :as => 'show_course'
  match 'calls/:id/show_bid_project', :to => 'bids#show_bid_project', :as => 'show_bid_project'
  match 'calls/:id/show_bid_user', :to => 'bids#show_bid_user', :as => 'show_bid_user'

  match 'project/:id/share', :to => 'projects#share', :as => 'share_show' #share

  post 'join_in/join', :to => 'courses#join', :as => 'join'
  delete 'join_in/join', :to => 'courses#unjoin'
  post 'join_in/join_group', :to => 'courses#join_group', :as => 'join_group'
  delete 'join_in/join_group', :to => 'courses#unjoin_group'
  post 'calls/:id/join_in_contest', :to => 'bids#join_in_contest', :as => 'join_in_contest'
  delete 'calls/:id/join_in_contest', :to => 'bids#unjoin_in_contest'
  match 'calls/:id/show_participator', :to => 'bids#show_participator'  # bai
  match 'calls/:id/update_contest', :to => 'bids#update_contest'    # bai
  match 'calls/:id/settings', :to => 'bids#settings'    # bai

  delete 'attachment/:id', :to => 'attachments#delete_homework'
  match 'new_join', :to => 'courses#new_join', :as => 'try_join'
  match 'new_join_group', :to => 'courses#new_join_group', :as => 'try_join_group'
  match 'new_join_in_contest', :to => 'bids#new_join', :as => 'try_join_in_contest'
  match 'projects/:id/respond', :to => 'projects#project_respond', :via => :post
  match 'calls/:id/manage',:to => 'bids#manage',:via => [:get,:post]


  #added by william
  # match 'calls/:id/set_results',:controller => 'bids', :action => 'set_results',:via => [:get,:post],:as => 'set_results'
  # match 'calls/:id/set_prizes',:controller => 'bids',:action => 'set_prizes',:as => 'set_prizes'
  match 'calls/:id/set_reward',:to => 'bids#set_reward',:as => 'set_reward'

  # added by young
  match 'calls', :to => 'bids#index'

  match 'calls/:id', :to => 'bids#show', :as => 'respond'
  # modified by longjun
  # bids#contests is not exist
  # match 'contest', :to => 'bids#contests', :as => 'contest' #modified @20140403
  # end longjun

  ########################
  ##added by wen##########
  #######confusing########
  get 'welcome/search', to: 'welcome#search'
  get 'school/index', to: 'school#index'
  get 'school/:school_id', to: 'welcome#course', :as => 'school_course_list'
  #get 'course/:school_id', to: 'welcome#course'
  post 'school/get_options/:province', :to => 'school#get_options'
  get 'school/get_options/:province', :to => 'school#get_options'

  post 'school/get_province', :to => 'school#get_province'
  get 'school/get_province', :to => 'school#get_province'

  post 'school/get_schoollist/:province', :to => 'school#get_schoollist'
  get 'school/get_schoollist/:province', :to => 'school#get_schoollist'

  post 'school/search_school/', :to => 'school#search_school'
  get 'school/search_school/', :to => 'school#search_school'

  post 'school/upload', :to => 'school#upload'
  get 'school/upload_logo', :to => 'school#upload_logo'

  ######added by nie
  match 'tags/show_projects_tags'
  ########### added by liuping
  match 'tags/add_tag', :as=>"add_tag"
  match 'tags/delete_tag', :as=>"add_tag"
  match 'tags/show_all'
  match 'parise_tread/praise_plus', :as=>"praise"
  match 'parise_tread/tread_plus', :as=>"tread"
  match 'tags/delete'
  match 'tags/remove_tag', :as=>"remove_tag"
  match 'tags/remove_tag_new', :as=>"remove_tag_new"
  match 'tags/tag_save', :as => "save_tag"

  match 'words/add_brief_introdution'


  Dir.glob File.expand_path("plugins/*", Rails.root) do |plugin_dir|
    file = File.join(plugin_dir, "config/routes.rb")
    if File.exists?(file)
      begin
        instance_eval File.read(file)
      rescue Exception => e
        puts "An error occurred while loading the routes definition of #{File.basename(plugin_dir)} plugin (#{file}): #{e.message}."
        exit 1
      end
    end
  end
end
